package org.jeecg.ctop.finance.policy.service.impl;

import cn.com.ctop.common.module.mapper.SysRoleMapper;
import cn.com.ctop.common.module.mapper.SysUserMapper;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.ctop.finance.policy.entity.CwjsSaleAssistantInfo;
import org.jeecg.ctop.finance.policy.mapper.CwjsSaleAssistantInfoMapper;
import org.jeecg.ctop.finance.policy.service.ICwjsSaleAssistantInfoService;
import org.jeecg.ctop.finance.policy.utils.Check;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.TreeSet;
import java.util.stream.Collectors;

/**
 * aaa
 * @author jeecg-boot
 * 2021-10-18
 * @version V1.0
 */
@Service
public class CwjsSaleAssistantInfoServiceImpl extends ServiceImpl<CwjsSaleAssistantInfoMapper, CwjsSaleAssistantInfo> implements ICwjsSaleAssistantInfoService {


    @Resource
    private  CwjsSaleAssistantInfoMapper cwjsSaleAssistantInfoMapper;

    @Resource
    private SysRoleMapper roleMapper;

    @Override
    public Result getSaleListByUserDepart(String userId) {
        List <CwjsSaleAssistantInfo> list = cwjsSaleAssistantInfoMapper.getSaleListByUserDepart(userId);
        return Result.successMsg("查询成功。",list);
    }



    public Result getCwSaleAndAssistantList(String userId){
        List<CwjsSaleAssistantInfo> resultList = new ArrayList();
        String roleCode = roleMapper.getRoleCodeByUserId(userId);
        //管理员 查询全部
        if (StringUtils.equals("admin",roleCode)){
            CwjsSaleAssistantInfo info = new CwjsSaleAssistantInfo();
            info.setSaleId(userId);
            info.setSaleName("管理员");
            resultList.add(info);//追加 管理员
            userId = null;
            //查询 销售
            List <CwjsSaleAssistantInfo> saleList = cwjsSaleAssistantInfoMapper.getCwSaleNameList(userId);
            resultList.addAll(saleList);
            //查询助理
            List <CwjsSaleAssistantInfo> assistantList = cwjsSaleAssistantInfoMapper.getCwAssistantNameList(userId);
            resultList.addAll(assistantList);
            resultList = resultList.stream().collect(Collectors.collectingAndThen(Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(CwjsSaleAssistantInfo :: getSaleId))),ArrayList :: new));
            return Result.successMsg("查询成功-管理员。",resultList);
        }
        //查询助理
        List <CwjsSaleAssistantInfo> assistantList = cwjsSaleAssistantInfoMapper.getCwAssistantNameList(userId);
        //如果该用户是 助理角色 则 对应的销售加自己的id list 必然 > 2
        if (assistantList.size() < 2){
            return Result.successMsg("查询成功-销售。",cwjsSaleAssistantInfoMapper.getCwSaleNameList(userId));
        }
        return Result.successMsg("查询成功-助理。",assistantList);


    }


}
